
"""
TEST THE ERS PROJECT

usage:

If running with current working directory in the project directory:

   >  python testproject.py

otherwise if running from the reportserver directory

   >  python testproject.py PROJECTNAME

OTHER ARGUMENTS
    stdout=filename
        - redirect standard output to filename listed.

The script attempts to execute dispatch (the project handler) on dictionary data
found in reportserver/projects/PROJECTNAME/test*.py.
"""

import string
cgi = 0

def testProject(cgi=cgi):
    import sys
    arguments = sys.argv[1:]
    for a in arguments[:]:
        if a[:7]=="stdout=":
            stdoutfile = a[7:]
            print "redirecting output to", stdoutfile
            sys.stdout = open(stdoutfile, "w")
            arguments.remove(a)
    if arguments:
        # remaining argument must be project name, from the reportserver cwd
        [projectname] = arguments # only one project allowed!
    else:
        # otherwise we must be running in the project directory with
        import os
        cwd = os.getcwd()
        scwd = string.split(cwd, os.sep)
        projectname = scwd[-1] # project name should be last directory in cwd
        # now set the current directory to the reportserver directory
        os.chdir("../..")
    if "." not in sys.path:
        sys.path.append(".")
    import dxcontroller
    dxcontroller.runTests(projectname)

if __name__=="__main__":
    testProject()
