import os
from rlextra.ers.webapp import WebApp
class GKTest(WebApp):
    def __init__(self,**kw):
        kw['authenticating'] = 1
        kw['authTimeOut'] = 5
        WebApp.__init__(self,**kw)

    def action_doHello(self, request, response):
        token = request.params.get('token','')
        textfield = request.params.get('textfield','')
        L = []
        for k,v in request.params.items():
            L.append("request.params[%s] = %s<br/>" % (repr(k),repr(v)))
        request_params=''.join(L)
        L = []
        for k,v in self.__dict__.items():
            L.append("self.%s = %s<br/>" % (k,repr(v)))
        self_dict = ''.join(L)
        response.write("""        
        <html>
        <head>
        <title>Untitled Document</title>        
        </head>        
        <body>
        <p>Old value of textfield was '%(textfield)s'</p>
        <form name="form1" method="post">
        <input type='hidden' name='token' value='%(token)s'>
        <p><input type="text" name="textfield" value='%(textfield)s'></p>
        <p><input type="submit" name="action" value="doHello"></p>
        </form>
        <h2>request.params</h2>
        %(request_params)s
        <h2>self.__dict__</h2>
        %(self_dict)s
        </body>
        </html>
        """%locals())
        return response
