

"""web widgets are reusable objects to put in web pages.

Basic use is dead simple:  call their render() method, passing
in an optional 'context'.  The idea is that in code (e.g.
in a prep file), you can initialize and call them,
and if needed customize on context.

<td>{{MenuBar().render()</td>
<td>{{MenuBar('download').render()</td>

or if you need to...
{{script}}
m = MenuBar()
m.currentTopic = 'download'
m.backColor = colors.pink
__write__(m.render())
{{endscript}}


Some people build object hierarchies to represent everything
in an HTML page, like the old HTMLGen.  We don't.  This is
intended for fairly complex stuff.
"""




class WebWidget:
    def renderHTML(self, context=None):
        return ''

